import java.util.*;

class Set {
    public Set() {
	this.theElements = new Vector<Object>();
    }
    
    public boolean isEmpty() {
	return this.theElements.isEmpty();
    }
    
    public int size() {
	return this.theElements.size();
    }
    
    Iterator<Object> iterator() {
	return this.theElements.iterator();
    }
 
    public boolean contains(Object o) {
	Iterator<Object> it = this.iterator();
	while (it.hasNext()) {
	    Object elem = it.next();
	    if (elem.equals(o))
		return true;
	}
	return false;
    }
    
    public void addElement(Object o) {
	if (!this.contains(o))
	    this.theElements.addElement(o);
    }
    
    public Set copy() {
	Set destSet = new Set();
	Iterator<Object> it = this.iterator();
	while (it.hasNext())
	    destSet.addElement(it.next());
	return destSet;
    }
    
    public Set union(Set s) {
	Set unionSet = s.copy();
	Iterator<Object> it = this.iterator();
	while (it.hasNext())
	    unionSet.addElement(it.next());
	return unionSet;
    }
    
    public Set intersection(Set s) {
	Set interSet = new Set();
	Iterator<Object> it = this.iterator();
	while (it.hasNext()) {
	    Object elem = it.next();
	    if (s.contains(elem))
		interSet.addElement(elem);
	}
	return interSet;
    }

    void removeAllElements() {
	this.theElements.removeAllElements();
    }
    
    public String toString(){
	String s = "[";
	Iterator<Object> it = this.iterator();
	if (it.hasNext())
	    s += it.next().toString();
	while (it.hasNext())
	    s += ", " + it.next().toString();
	return s + "]";
    }
    
    private Vector<Object> theElements;
}
