import java.util.*;

class SetEnum {
    public SetEnum() {
	this.theElements = new Vector<Object>();
    }
    
    public boolean isEmpty() {
	return this.theElements.isEmpty();
    }
    
    public int size() {
	return this.theElements.size();
    }
    
    Enumeration<Object> elements() {
	return this.theElements.elements();
    }
    
    public boolean contains(Object o) {
	Enumeration<Object> en = this.elements();
	while (en.hasMoreElements()) {
	    Object elem = en.nextElement();
	    if (elem.equals(o))
		return true;
	}
	return false;
    }
    
    public void addElement(Object o) {
	if (!this.contains(o))
	    this.theElements.addElement(o);
    }
    
    public SetEnum copy() {
	SetEnum destSetEnum = new SetEnum();
	Enumeration<Object> en = this.elements();
	while (en.hasMoreElements())
	    destSetEnum.addElement(en.nextElement());
	return destSetEnum;
    }
    
    public SetEnum union(SetEnum s) {
	SetEnum unionSetEnum = s.copy();
	Enumeration<Object> en = this.elements();
	while (en.hasMoreElements())
	    unionSetEnum.addElement(en.nextElement());
	return unionSetEnum;
    }
    
    public SetEnum intersection(SetEnum s) {
	SetEnum interSetEnum = new SetEnum();
	Enumeration<Object> en = this.elements();
	while (en.hasMoreElements()) {
	    Object elem = en.nextElement();
	    if (s.contains(elem))
		interSetEnum.addElement(elem);
	}
	return interSetEnum;
    }

    void removeAllElements() {
	this.theElements.removeAllElements();
    }
    
    public String toString(){
	String s = "[";
	Enumeration<Object> en = this.elements();
	if (en.hasMoreElements())
	    s += en.nextElement().toString();
	while (en.hasMoreElements())
	    s += ", " + en.nextElement().toString();
	return s + "]";
    }
    
    private Vector<Object> theElements;
}
